import { createRouter, createWebHistory } from "vue-router";
import NotFoundPage from "@/pages/NotFoundPage.vue";
import routes from "@/routes";
import store from "@/store";
const router = createRouter({
    // Options
    history: createWebHistory(),
    routes: [...routes,
        {
            path: "/:pathMatch(.*)*",
            component: NotFoundPage,
            // Alternativ mit Redirect auf Root
            //            redirect: "/"
        }
    ]
});
function sleep(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
}
router.beforeEach(async (to, from, next) => {
    if (to.meta.requiresAuth) {
        // @ts-ignore
        const kc = store.getters.keycloak;
        console.log(kc);
        while (typeof kc == "undefined" || kc.createLoginUrl === null) {
            await sleep(100);
        }
        if (kc.authenticated) {
            next();
        }
        else {
            const loginUrl = kc.createLoginUrl();
            window.location.replace(loginUrl);
        }
    }
    else {
        next();
    }
});
export default router;
//# sourceMappingURL=index.js.map