export default class InventoryItem {
    FIELDS = ['item_type', 'manufacturer_key', 'brand_key', 'condition_key',
        'name', 'description', 'work_done', 'special',
        'price_purchased', 'price_historic', 'price_current',
        'year_of_production', 'year_of_purchase', 'inventory_number', 'set_key'];
    _key;
    _inventory_number;
    _item_type;
    _active;
    _edit;
    _manufacturer_key;
    _brand_key;
    _condition_key;
    _name;
    _description;
    _work_done;
    _special;
    _price_purchased;
    _price_historic;
    _price_current;
    _year_of_production;
    _year_of_purchase;
    _set_key;
    _created;
    _changed;
    constructor(key, name, values) {
        this._key = key;
        this._name = name;
        this._active = false;
        this._edit = false;
        this._created = new Date();
        this._changed = new Date();
        if (typeof values != "undefined") {
            for (const field of this.FIELDS) {
                if (field in values)
                    this["_" + field] = values[field];
            }
        }
    }
    getDBVersion() {
        const obj = {
            key: this._key,
            item_type: this._item_type,
            manufacturer_key: this._manufacturer_key,
            brand_key: this._brand_key,
            condition_key: this._condition_key,
            name: this._name,
            description: this._description,
            work_done: this._work_done,
            special: this._special,
            price_purchased: this._price_purchased,
            price_historic: this._price_historic,
            price_current: this._price_current,
            year_of_production: this._year_of_production,
            year_of_purchase: this._year_of_purchase,
            inventory_number: this._inventory_number,
            set_key: this._set_key
        };
        return obj;
    }
    get key() {
        return this._key;
    }
    get active() {
        return this._active;
    }
    get edit() {
        return this._edit;
    }
    get item_type() {
        return this._item_type;
    }
    get manufacturer_key() {
        return this._manufacturer_key;
    }
    get brand_key() {
        return this._brand_key;
    }
    get condition_key() {
        return this._condition_key;
    }
    get name() {
        return this._name;
    }
    get description() {
        return this._description;
    }
    get work_done() {
        return this._work_done;
    }
    get special() {
        return this._special;
    }
    get price_purchased() {
        return this._price_purchased;
    }
    get price_historic() {
        return this._price_historic;
    }
    get price_current() {
        return this._price_current;
    }
    get year_of_production() {
        return this._year_of_production;
    }
    get year_of_purchase() {
        return this._year_of_purchase;
    }
    set active(value) {
        this._active = value;
    }
    set edit(value) {
        this._edit = value;
    }
    set manufacturer_key(value) {
        this._manufacturer_key = value;
    }
    set brand_key(value) {
        this._brand_key = value;
    }
    set condition_key(value) {
        this._condition_key = value;
    }
    set name(value) {
        this._name = value;
    }
    set description(value) {
        this._description = value;
    }
    set work_done(value) {
        this._work_done = value;
    }
    set special(value) {
        this._special = value;
    }
    set price_purchased(value) {
        this._price_purchased = Number(value);
    }
    set price_historic(value) {
        this._price_historic = Number(value);
    }
    set price_current(value) {
        this._price_current = Number(value);
    }
    set year_of_production(value) {
        this._year_of_production = value;
    }
    set year_of_purchase(value) {
        this._year_of_purchase = value;
    }
    get set_key() {
        return this._set_key;
    }
    set set_key(value) {
        this._set_key = value;
    }
    get inventory_number() {
        return this._inventory_number;
    }
    get created() {
        return this._created;
    }
    get changed() {
        return this._changed;
    }
    set changed(value) {
        this._changed = value;
    }
}
//# sourceMappingURL=InventoryItem.js.map