import InventoryItem from "@/store/classes/InventoryItem";

export default class InventorySet extends InventoryItem {

    private ADD_FIELDS = ['inventory_keys'];

    private _inventory_keys: string[];

    constructor(id:string, name:string, values?:Object) {
        super(id, name, values);
        this._item_type = "lens";

            if(typeof values != "undefined") {
                for (const field  of this.ADD_FIELDS) {
                    if(field in values) this["_" + field] = values[field];
                }
            }
    }
    getDBVersion():object {
        const obj = {
            key: this.key,
            item_type: this._item_type,
            manufacturer_key: this.manufacturer_key,
            brand_key: this.brand_key,
            condition_key: this.condition_key,
            name: this.name,
            description: this.description,
            work_done: this.work_done,
            special: this.special,
            price_purchased: this.price_purchased,
            price_historic: this.price_historic,
            price_current: this.price_current,
            year_of_production: this.year_of_production,
            year_of_purchase: this.year_of_purchase,
            inventory_number: this.inventory_number,
            set_key: this.set_key,
            inventory_keys: this._inventory_keys
        }
        return obj
    }

    get inventory_keys(): string[] {
        return this._inventory_keys;
    }
}

